;-- TIME_STAMP   2019-05-13 00:12:49   v 1.1

#Region **** Directives created by AutoIt3Wrapper_GUI ****
;~ #AutoIt3Wrapper_Icon=Icons\LPSicon.ico
#AutoIt3Wrapper_Res_Language=1031
#AutoIt3Wrapper_AU3Check_Parameters=-q -d -w 1 -w 2 -w 3 -w- 4 -w 5 -w 6 -w- 7
#EndRegion **** Directives created by AutoIt3Wrapper_GUI ****

#Region    ;************ Includes ************
#include <StaticConstants.au3>
#include <Array.au3>
#include <Debug.au3>
#include <GuiToolbar.au3>
#include <_SciTE_Interface.au3>
#include <Misc.au3>
#EndRegion ;************ Includes ************

#NoTrayIcon

If Not @Compiled Then
	If ProcessExists('_SciTE_ShowFuncName.exe') Then
		ProcessClose('_SciTE_ShowFuncName.exe')
		Exit
	Else
		_SetHotKey('^+{F1}', '_F1') ; Ctrl+Shift+F1
		_SetHotKey('^!x', '_Exit') ; Ctrl+Alt+X
	EndIf
EndIf

_Singleton('_SciTE_ShowFuncName') ; Enforce a design paradigm where only one instance of the script may be running

Global Enum $ehScITE, $ehToolBar, $eaPosToolBar, $ehChild, $eaChildPos, $eidLabel_FuncName, $ehSource, $eaSource, $esSource, $esEOLMode, $esFuncName, $esOldFuncName, $eiCurrentPos, $eiCurrentLineNumber, $eaRX, $esSizeOff
Global $g_aSciTE[0][$esSizeOff]

Global $g_hGUI = GUICreate('')
GUISetState(@SW_SHOWMINNOACTIVE)

;~ _SciTE_ShowFuncName() ; Init

Do
	If _WinAPI_GetClassName(WinGetHandle('[ACTIVE]')) = 'SciTEWindow' Then _SciTE_ShowFuncName()
	Sleep(250)
Until GUIGetMsg() = -3

Func _SciTE_ShowFuncName()
	Local $aWinList, $hScITE, $hToolBar, $aClientSize, $aMaxSize, $aPosToolBar, $aOldPosToolBar, $hChild, $sCurrentFileName, $hSource, $aSource, $sSource, $sEOLMode, $iMixedEOLMode, $iCurrentPos, $iCurrentLineNumber, $aFuncs

	$aWinList = WinList('[CLASS:SciTEWindow]') ; Title, Handle
;~ 	_ArrayDisplay($aWinList, '$aWinList')
	If UBound($aWinList) < 2 Then
		ReDim $g_aSciTE[0][$esSizeOff]
		Return
	EndIf

	Local $iIndex = UBound($g_aSciTE)
	For $i = $aWinList[0][0] To 1 Step -1
		_ArraySearch($g_aSciTE, $aWinList[$i][1])
		If @error Then
			ReDim $g_aSciTE[$iIndex + 1][$esSizeOff]
			$g_aSciTE[$iIndex][$ehScITE] = $aWinList[$i][1]
			$iIndex += 1
		EndIf
	Next

	If UBound($g_aSciTE) Then
		For $i = UBound($g_aSciTE) -1 To 0 Step -1
			If Not WinExists($g_aSciTE[$i][$ehScITE]) Then
				GUIDelete($g_aSciTE[$i][$ehChild])
				If _ArrayDelete($g_aSciTE, $i) = 0 Then Return
				ContinueLoop
			EndIf
			If Not UBound($g_aSciTE) Then Return

			If Not $g_aSciTE[$i][$ehToolBar] Then
				$hToolBar = ControlGetHandle($g_aSciTE[$i][$ehScITE], '', '[CLASS:ToolbarWindow32; INSTANCE:1]')
				$g_aSciTE[$i][$ehToolBar] = $hToolBar
				$aMaxSize = _GUICtrlToolbar_GetMaxSize($hToolBar)
;~ 				_PrintClientSize('! $aMaxSize', $aMaxSize)
				$aPosToolBar = ControlGetPos($hToolBar, '', '')
				$g_aSciTE[$i][$eaPosToolBar] = $aPosToolBar
;~ 				$hChild = GUICreate("Child", $aPosToolBar[2] - $aMaxSize[0], $aPosToolBar[3], $aPosToolBar[2] - $aMaxSize[0], $aPosToolBar[1], $WS_CHILD, $WS_EX_TOPMOST, $hToolBar)
				$hChild = GUICreate("Child", $aPosToolBar[2] - $aMaxSize[0] - 8, $aPosToolBar[3] - 2, $aMaxSize[0] + 5, $aPosToolBar[1], $WS_CHILD, $WS_EX_TOPMOST, $hToolBar)
				$g_aSciTE[$i][$ehChild] = $hChild
				$g_aSciTE[$i][$eaChildPos] = WinGetPos($hChild)
				$aClientSize = WinGetClientSize($hChild)
;~ 				$g_aSciTE[$i][$eidLabel_FuncName] = GUICtrlCreateLabel('', 0, 0, 320, $aPosToolBar[3]) ; Max 56 Chars!
				$g_aSciTE[$i][$eidLabel_FuncName] = GUICtrlCreateLabel('', 0, 0, $aClientSize[0], $aClientSize[1], BitOR($GUI_SS_DEFAULT_LABEL, $SS_SUNKEN, $SS_CENTERIMAGE)) ; Max 56 Chars!
				GUICtrlSetFont(-1, 11, 900, 0, 'Courier New')
				GUISetState(@SW_SHOWNOACTIVATE)
;~ 				_WinAPI_RedrawWindow($hToolBar)
				$g_aSciTE[$i][$ehSource] = ControlGetHandle($g_aSciTE[$i][$ehScITE], '', '[CLASS:Scintilla; INSTANCE:1]')
				GUISwitch($g_hGUI)
			EndIf
		Next
;~ 		_DebugArrayDisplay($g_aSciTE, '$g_aSciTE')

		For $i = 0 To UBound($g_aSciTE) -1 Step 1
			$hScITE = $g_aSciTE[$i][$ehScITE]
			If Not IsHWnd($hScITE) Or Not BitAND(WinGetState($hScITE), $WIN_STATE_VISIBLE) Or BitAND(WinGetState($hScITE), $WIN_STATE_MINIMIZED) Then ContinueLoop
;~ 			ConsoleWrite('----------------------------------------------------------------------------------------------' & @CRLF)
;~ 			_CW("+ $hScITE = " & $hScITE)
			$sCurrentFileName = _SciTE_GetCurrentFileName($hSciTE)
;~ 			_CW("$sCurrentFileName          --> " & $sCurrentFileName)
			If StringRight($sCurrentFileName, 3) <> 'au3' Then ContinueLoop

			$aPosToolBar = ControlGetPos($g_aSciTE[$i][$ehToolBar], '', '')
			If @error Then ContinueLoop
			$aOldPosToolBar = $g_aSciTE[$i][$eaPosToolBar]
			If $aPosToolBar[2] <> $aOldPosToolBar[2] Then
				$g_aSciTE[$i][$eaPosToolBar] = $aPosToolBar
				$aMaxSize = _GUICtrlToolbar_GetMaxSize($g_aSciTE[$i][$ehToolBar])
				WinMove($g_aSciTE[$i][$ehChild], '', $aMaxSize[0] + 5, $aPosToolBar[1], $aPosToolBar[2] - $aMaxSize[0] - 8, $aPosToolBar[3] - 2)
				$aClientSize = WinGetClientSize($g_aSciTE[$i][$ehChild])
				GUICtrlSetPos($g_aSciTE[$i][$eidLabel_FuncName], 0, 0, $aClientSize[0], $aClientSize[1])
			EndIf

			$hSource = $g_aSciTE[$i][$ehSource]
			$sSource = ControlGetText($hSource, '', '')
			$sEOLMode = _GetEOLMode($sSource, $hScITE)
			$iMixedEOLMode = @extended
;~ 			_CW(" $iMixedEOLMode = " & $iMixedEOLMode & " $sCurrentFileName = " & $sCurrentFileName)
;~ 			_CW("$sEOLMode                  --> " & Binary($sEOLMode))
			$aSource = StringRegExp($sSource, $sEOLMode&'|.+' & $sEOLMode & '|.+', 3)
;~ 			_DebugArrayDisplay($aSource, '$aSource')

			Switch $sEOLMode
				Case False
					Exit @ScriptLineNumber
				Case @LF
;~ 					_CW("! $sCurrentFileName          --> " & $sCurrentFileName)
;~ 					_CW("! $sEOLMode                  --> " & Binary($sEOLMode))
;~ 					_DebugArrayDisplay($aSource, '$aSource')
			EndSwitch

			If UBound($aSource) Then
				If StringRight($aSource[UBound($aSource) -1], StringLen($sEOLMode)) = $sEOLMode Then _ArrayAdd($aSource, '')
				$iCurrentPos = _SciTE_GetCurrentPosition($hScITE, $eSCI_EditorPane)
;~ 				_CW("$iCurrentPos               --> " & $iCurrentPos)
				$iCurrentLineNumber = _SciTE_GetLineFromPosition($iCurrentPos, $hScITE, $eSCI_EditorPane)
;~ 				_CW("$hSource                   --> " & $hSource)
;~ 				_CW("! $iCurrentLineNumber      --> " & $iCurrentLineNumber)
;~ 				Exit

				$aFuncs = _ArrayFindAll($aSource, '^(Func|EndFunc)', 0, 0, 0, 3)
				$g_aSciTE[$i][$esFuncName] = ''
				Local $iFuncNameLineNumber = -1
				If UBound($aFuncs) -1 > 0 Then
;~ 					_DebugArrayDisplay($aFuncs, '$aFuncs')
					For $j = 0 To UBound($aFuncs) -1 Step 2
						Switch True
							Case $aFuncs[$j] <= $iCurrentLineNumber And $j + 1 <= UBound($aFuncs) -1 And $aFuncs[$j + 1] >= $iCurrentLineNumber
								If StringLeft($aSource[$aFuncs[$j]], 4) = 'Func' And StringLeft($aSource[$aFuncs[$j + 1]], 7) = 'EndFunc' Then
;~ 									_CW("> $aSource[$aFuncs[$j]]      --> " & $aSource[$aFuncs[$j]])
;~ 									_CW("$aSource[$aFuncs[$j +1]] --> " & $aSource[$aFuncs[$j +1]])

									; StringRegExpReplace
;~ 									$g_aSciTE[$i][$esFuncName] = StringRegExpReplace($aSource[$aFuncs[$j]], 'Func\s(\w+).*', '\1') ; ohne Parameter
									$g_aSciTE[$i][$esFuncName] = StringRegExpReplace($aSource[$aFuncs[$j]], 'Func\s(.+\)).*', '\1') ; mit Parameter

									; StringRegExp
;~ 									$aRX = StringRegExp($aSource[$aFuncs[$j]], '(?U)Func\s(.+)\(.*', 1) ; ohne Parameter
;~ 									$aRX = StringRegExp($aSource[$i][1], '(?U)Func\s(.+\)+).*', 1) ; mit Parameter
;~ 									$g_aSciTE[$i][$esFuncName] = @error ? '' : $aRX[0]
									$iFuncNameLineNumber = $aFuncs[$j]
									ExitLoop
								EndIf
						EndSwitch
					Next
				EndIf
			Else
				$g_aSciTE[$i][$esFuncName] = ''
			EndIf

			If $iMixedEOLMode Then $g_aSciTE[$i][$esFuncName] = 'Mixed EOLMode!'

;~ 			_CW("$hSource                   --> " & $hSource)
;~ 			_CW("FuncName                   --> " & StringStripWS($g_aSciTE[$i][$esFuncName], $STR_STRIPTRAILING))
			If $g_aSciTE[$i][$esOldFuncName] <> $g_aSciTE[$i][$esFuncName] Then
				$g_aSciTE[$i][$esOldFuncName] = $g_aSciTE[$i][$esFuncName]
				GUICtrlSetData($g_aSciTE[$i][$eidLabel_FuncName], ' ' & $g_aSciTE[$i][$esFuncName])

				If $iMixedEOLMode Then
					$iMixedEOLMode = 0
					GUICtrlSetColor($g_aSciTE[$i][$eidLabel_FuncName], 0xFF0000)
				ElseIf $g_aSciTE[$i][$esFuncName] Then
;~ 					_CW("$iCurrentPos               --> " & $iCurrentPos)
;~ 					_CW("$iCurrentLineNumber        --> " & $iCurrentLineNumber)

;~ 					_CW("$iFuncNameLineNumber       --> " & $iFuncNameLineNumber)
					Local $iFuncNamePosition = _SciTE_GetPositionFromLine($iFuncNameLineNumber, $hScITE, $eSCI_EditorPane)
;~ 					_CW("$iFuncNamePosition         --> " & $iFuncNamePosition)
					Local $iStyle = _SciTE_GetStyleAt($iFuncNamePosition + 5, $hScITE, $eSCI_EditorPane) ; 15 = Standard UDF, 16 = User UDF or 0 = Unknown UDF
;~ 					_CW("$iStyle                    --> " & $iStyle)
					Local $sColor = _SciTE_GetProperty('style.au3.' & $iStyle, $hScITE)
;~ 					_CW("$sColor                    --> " & $sColor)
					Local $iColor = $sColor ? StringRegExpReplace($sColor, '(?i)fore:#([0-9a-f]+).*', '0x\1') : 0x000000
;~ 					_CW("$iColor                    --> " & $iColor)
					GUICtrlSetColor($g_aSciTE[$i][$eidLabel_FuncName], $iColor)
				Else
					GUICtrlSetColor($g_aSciTE[$i][$eidLabel_FuncName], 0x000000)
				EndIf
			EndIf
;~ 			ConsoleWrite('----------------------------------------------------------------------------------------------' & @CRLF)
;~ 			ConsoleWrite(@CRLF)
		Next
	EndIf
EndFunc   ;==>_SciTE_ShowFuncName

Func _GetEOLMode(ByRef $sSource, $hScITE = '')
	Local $eolauto = _SciTE_GetProperty('eol.auto', $hScITE)
	Local $eolmode = _SciTE_GetProperty('eol.mode', $hScITE)
	If @error Then Return SetError(1, 0, False)

	Local $iEOL, $iCRLF, $iLF
	Switch True
		Case $eolauto = 1, $eolmode = ''
			If $sSource Then
				StringReplace($sSource, @CRLF, '')
				$iCRLF = @extended
				StringReplace($sSource, @LF, '')
				$iLF = @extended
				$iEOL = $iCRLF >= $iLF ? @CRLF : @LF
			Else
				$iEOL = @CRLF
			EndIf
		Case Else
			$iEOL = '@' & $eolmode
	EndSwitch
	Return SetExtended(($iCRLF > 0 And $iLF > 0) And ($iCRLF <> $iLF) ? 1 : 0, $iEOL)
EndFunc  ;==>_GetEOLMode

Func _SetHotKey($sHotKey, $sFunction)
	If Not HotKeySet($sHotKey, $sFunction) Then Exit MsgBox(16, @ScriptName, 'HotKey "' & $sHotKey & '" konnte nicht gesetzt werden!')
EndFunc  ;==>_SetHotKey

Func _F1()
	_DebugArrayDisplay($g_aSciTE, '$g_aSciTE')
EndFunc  ;==>_F1

Func _Exit()
	Exit
EndFunc  ;==>_Exit

; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

; Standard-UDF
Func _ColorGetCOLORREF($iColor, Const $_iCurrentExtended = @extended)
	If BitAND($iColor, 0xFF000000) Then Return SetError(1, 0, 0) ; invalid color value
	Local $aColor[3]
	$aColor[2] = BitAND(BitShift($iColor, 16), 0xFF)
	$aColor[1] = BitAND(BitShift($iColor, 8), 0xFF)
	$aColor[0] = BitAND($iColor, 0xFF)
	Return SetExtended($_iCurrentExtended, $aColor)
EndFunc   ;==>_ColorGetCOLORREF

; User-UDF
Func _ComErrorHandler()
EndFunc  ;==>_ComErrorHandler
